﻿using Android.Speech.Tts;
using Java.Util;
using Android.OS;
using Android.App;

namespace CameraDroid
{
	public class Speech_Droid : Java.Lang.Object, TextToSpeech.IOnInitListener
	{
		TextToSpeech _textToSpeech;
		string _toSpeak;

		public void Speak(Activity activity,string text)
		{
			if (!string.IsNullOrWhiteSpace(text))
			{
				_toSpeak = text;
				if (_textToSpeech == null)
				{
					_textToSpeech = new TextToSpeech(activity, this);
				}
				else {
					OnSpeak(_toSpeak);
				}
			}
		}

		public void OnInit(OperationResult status)
		{
			if (status.Equals(OperationResult.Success))
			{
				OnSpeak(_toSpeak);
			}
		}

		private void OnSpeak(string text)
		{
			Locale loc = Locale.English;
			switch (_textToSpeech.IsLanguageAvailable(loc))
			{
				case Android.Speech.Tts.LanguageAvailableResult.MissingData:
				case Android.Speech.Tts.LanguageAvailableResult.NotSupported:
					break;
				default:
					_textToSpeech.SetLanguage(loc);
					if (Build.VERSION.SdkInt >= Android.OS.BuildVersionCodes.Lollipop)
					{
						_textToSpeech.Speak(text, QueueMode.Flush, null, null);
					}
					else
					{
						_textToSpeech.Speak(text, QueueMode.Flush, null);
					}
					break;
			}
		}
	}
}
